<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEngineloadRPMItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfEngineloadRPMItem extends AbstractStructArrayBase
{
    /**
     * The EngineloadRPMItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EngineloadRPMItem[]
     */
    public $EngineloadRPMItem;
    /**
     * Constructor method for ArrayOfEngineloadRPMItem
     * @uses ArrayOfEngineloadRPMItem::setEngineloadRPMItem()
     * @param \StructType\EngineloadRPMItem[] $engineloadRPMItem
     */
    public function __construct(array $engineloadRPMItem = array())
    {
        $this
            ->setEngineloadRPMItem($engineloadRPMItem);
    }
    /**
     * Get EngineloadRPMItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EngineloadRPMItem[]|null
     */
    public function getEngineloadRPMItem()
    {
        return isset($this->EngineloadRPMItem) ? $this->EngineloadRPMItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEngineloadRPMItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEngineloadRPMItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEngineloadRPMItemForArrayConstraintsFromSetEngineloadRPMItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEngineloadRPMItemEngineloadRPMItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfEngineloadRPMItemEngineloadRPMItemItem instanceof \StructType\EngineloadRPMItem) {
                $invalidValues[] = is_object($arrayOfEngineloadRPMItemEngineloadRPMItemItem) ? get_class($arrayOfEngineloadRPMItemEngineloadRPMItemItem) : sprintf('%s(%s)', gettype($arrayOfEngineloadRPMItemEngineloadRPMItemItem), var_export($arrayOfEngineloadRPMItemEngineloadRPMItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EngineloadRPMItem property can only contain items of type \StructType\EngineloadRPMItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EngineloadRPMItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EngineloadRPMItem[] $engineloadRPMItem
     * @return \ArrayType\ArrayOfEngineloadRPMItem
     */
    public function setEngineloadRPMItem(array $engineloadRPMItem = array())
    {
        // validation for constraint: array
        if ('' !== ($engineloadRPMItemArrayErrorMessage = self::validateEngineloadRPMItemForArrayConstraintsFromSetEngineloadRPMItem($engineloadRPMItem))) {
            throw new \InvalidArgumentException($engineloadRPMItemArrayErrorMessage, __LINE__);
        }
        if (is_null($engineloadRPMItem) || (is_array($engineloadRPMItem) && empty($engineloadRPMItem))) {
            unset($this->EngineloadRPMItem);
        } else {
            $this->EngineloadRPMItem = $engineloadRPMItem;
        }
        return $this;
    }
    /**
     * Add item to EngineloadRPMItem value
     * @throws \InvalidArgumentException
     * @param \StructType\EngineloadRPMItem $item
     * @return \ArrayType\ArrayOfEngineloadRPMItem
     */
    public function addToEngineloadRPMItem(\StructType\EngineloadRPMItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EngineloadRPMItem) {
            throw new \InvalidArgumentException(sprintf('The EngineloadRPMItem property can only contain items of type \StructType\EngineloadRPMItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EngineloadRPMItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EngineloadRPMItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EngineloadRPMItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EngineloadRPMItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EngineloadRPMItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EngineloadRPMItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EngineloadRPMItem
     */
    public function getAttributeName()
    {
        return 'EngineloadRPMItem';
    }
}
